<template>
  <div>
    <v-form @submit.prevent>
      <v-card-item>
        <h1 class="text-center">Login</h1>
        <v-alert
            color="error"
            class="mb-4"
            closable
            v-model="showInvalidCredentialsWarning">
          <p>Falscher Username oder Passwort</p>
        </v-alert>

        <v-text-field
            v-model="credentials.username"
            label="Username"
            type="text"
            required
            variant="outlined"
            maxlength="255"
            autocomplete="username"/>
        <v-text-field
            v-model="credentials.password"
            label="Passwort"
            type="password"
            required
            variant="outlined"
            maxlength="255"
            minlength="8"
            autocomplete="password"
            class="mb-4"/>

        <a v-show="!demoLogin" @click="demoLogin = !demoLogin" href="#">LOGIN DATEN</a>
        <p v-show="demoLogin">[Usernames: admin, manager, user] [Password: iperia123]</p>
        <v-btn type="submit" color="blue-darken-4" block class="mb-2" @click="login">Login</v-btn>
        <v-snackbar location="bottom end">
          Ein unbekannter Fehler ist aufgetreten. Bitte versuchen Sie es später erneut.
        </v-snackbar>
      </v-card-item>
    </v-form>
  </div>
</template>

<script setup>
import { useAuthStore } from '@/stores/authStore'
import { ref } from 'vue'
import { useRouter } from 'vue-router'
import { isAxiosError } from 'axios'

const authStore = useAuthStore();

const router = useRouter();

const showInvalidCredentialsWarning = ref(false)
const showUnknownError = ref(false)
const demoLogin = ref(false)
const credentials = ref({
  username: '',
  password: ''
})

async function login () {
  try {
    await authStore.login(credentials.value)
    await router.push("/dashboard")
  } catch (err) {
    if (isAxiosError(err) && err.response?.status === 401) {
      return showInvalidCredentialsWarning.value = true
    }
    showInvalidCredentialsWarning.value = true
    console.error(err)
    showUnknownError.value = true
  }
}
</script>
